<template>
  <section
    id="cart"
    class="cart-page animate__animated animate__fadeIn animate__faster"
  >
    <CartBanner />

    <CartListMobile v-if="!loading" />

    <div class="desktop-items mt-4" v-if="!loading">
      <CartListDesktop />

      <section class="summary pt-3 pt-md-0" v-if="cart.length">
        <div class="container">
          <div class="row">
            <div class="col">
              <div class="summary-card p-3">
                <h3 class="title">Resumen</h3>

                <!-- <div
                  class="d-flex justify-content-between align-items-center mt-3"
                >
                  <h4>Subtotal</h4>
                  <span class="font-weight-bold">{{ price(subTotal) }}</span>
                </div> -->

                <div
                  class="d-flex justify-content-between align-items-center mt-3"
                >
                  <h4>Total</h4>
                  <span class="font-weight-bold">{{ price(subTotal) }}</span>
                </div>

                <div class="buttons mt-3">
                  <nuxt-link to="/" class="btn btn-outline-primary"
                    >Seguir comprando</nuxt-link
                  >
                  <a
                    href=""
                    class="btn btn-success text-white text-uppercase"
                    @click.prevent="process()"
                  >
                    Ir a pagar
                  </a>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
    </div>
  </section>
</template>

<script>
import { appConfig } from "@/app-config.js";

import { mapGetters } from "vuex";

import { priceFormat } from "@/utils/price-format.js";

import GetGetProductoSlug from "@/graphql/queries/productos/GetGetProductoSlug.gql";

import CartBanner from "@/components/cart/CartBanner";
import CartListMobile from "@/components/cart/CartListMobile";
import CartListDesktop from "@/components/cart/CartListDesktop";

export default {
  data() {
    return {
      appConfig,
    };
  },
  components: {
    CartBanner,
    CartListMobile,
    CartListDesktop,
  },
  async created() {
    setTimeout(() => {
      this.getProductsInfo();
    }, 500);
  },
  methods: {
    async getProductsInfo() {
      this.$store.commit("SET_LOADER", true);

      let cart = JSON.parse(JSON.stringify(this.cart));

      await Promise.all(
        cart.map(async (item, index) => {
          let res = await this.$apollo.query({
            query: GetGetProductoSlug,
            variables: {
              slug: item.slug,
            },
          });

          let data = {
            ...res.data.GetGetProductoSlug,
          };

          let product = cart[index];
          product.id = data.id;
          product.name = data.nombre;
          product.slug = data.slug;
          product.precio_descuento = data.precio_descuento;
          product.precio_real = data.precio_real;
          product.foto_real = data.foto_real;
          product.stok_real = data.stok_real;
        })
      )
        .then(() => {
          this.$store.commit("cart/SET_PRODUCTS", cart);

          this.$store.commit("SET_LOADER", false);
        })
        .catch(() => {
          this.$store.commit("SET_LOADER", false);
        });
    },
    price(val) {
      return priceFormat(val);
    },
    process() {
      let text = `Hola, estoy interesad@ en estos productos, bríndeme información de los métodos de pago por favor: %0A %0A`;

      this.cart.forEach((item) => {
        if (item.precio_descuento) {
          text =
            text +
            `${item.name} %0A
Precio real: ${this.price(item.precio_real)} %0A
Precio con descuento: ${this.price(item.precio_descuento)} %0A
Cantidad: ${item.quantity} %0A
URL: https://rongqian.pe/productos/${item.slug} %0A %0A`;
        } else {
          text =
            text +
            `${item.name} %0A
Precio real: ${this.price(item.precio_real)} %0A
Cantidad: ${item.quantity} %0A
URL: https://rongqian.pe/productos/${item.slug} %0A %0A`;
        }
      });

      window.open(
        `https://api.whatsapp.com/send?phone=${this.appConfig.contact.whatsapp}&text=${text}`,
        "_blank"
      );
    },
  },
  computed: {
    ...mapGetters({
      cart: "cart/getCart",
      subTotal: "cart/getSubTotal",
      loading: "isLoading",
    }),
  },
};
</script>

<style lang="scss" scoped>
@import "~/assets/scss/variables";

.cart-page {
  height: calc(90vh - $header-mobile-height);

  @media (min-width: 992px) {
    height: auto;
  }
}

.desktop-items {
  height: 30%;
  display: grid;

  @media (min-width: 992px) {
    height: auto;
    grid-template-columns: 58% 40%;
  }
}

.summary {
  height: 30%;

  @media (min-width: 992px) {
    height: auto;
  }

  .title {
    font-size: 1.2em;
    font-weight: 700;
  }

  h4 {
    font-size: 1.2em;
    font-weight: 500;

    @media (min-width: 992px) {
      font-size: 1em;
      font-weight: 500;
    }
  }

  .buttons {
    display: grid;
    grid-template-columns: 48% 48%;
    grid-gap: 4%;

    .btn {
      font-size: 0.8em;
    }
  }

  &-card {
    box-shadow: 0 3px 6px rgb(0 0 0 / 8%);
  }
}
</style>
